"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.createSSITag = function (url) { return "<!--#include virtual=\"" + url + "\" -->"; };
exports.getInitialHtml = function (id, defaultHtml, isOnClient) {
    if (isOnClient && window) {
        var element = window.document.getElementById(id);
        return element ? element.innerHTML : defaultHtml;
    }
    return defaultHtml;
};
exports.ownFetch = function (url) {
    return new Promise(function (resolve, reject) {
        var xhr = new window.XMLHttpRequest();
        xhr.open('GET', url);
        xhr.onload = function () { return resolve(xhr.response); };
        xhr.onerror = function () { return reject(new Error("Failed to load " + url + ". Got status " + xhr.status + ".")); };
        xhr.send();
    });
};
exports.isFallbackNecessary = function (url, initialHtml) { return exports.createSSITag(url) === initialHtml; };
exports.remountScripts = function (id) {
    var document = window.document;
    if (document) {
        var element = document.getElementById(id);
        if (element) {
            Array.prototype.slice.call(element.querySelectorAll('script'), 0).forEach(function (script) {
                var newScript = document.createElement('script');
                if (script.src) {
                    if (script.getAttribute('type')) {
                        newScript.setAttribute('type', script.getAttribute('type') || '');
                    }
                    if (script.getAttribute('nomodule') !== null) {
                        newScript.setAttribute('nomodule', script.getAttribute('nomodule') || '');
                    }
                    newScript.src = script.src;
                }
                else {
                    newScript.textContent = script.textContent;
                }
                document.body.appendChild(newScript);
            });
        }
    }
};
